/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.Text;

namespace STSdb.Data
{
    [Serializable]
    public class Row<TKey, TRecord>
    {
        public TKey Key { get; set; }
        public TRecord Record { get; set; }

        public Row()
            : this(default(TKey), default(TRecord))
        {
        }

        public Row(TKey key, TRecord record)
        {
            Key = key;
            Record = record;
        }

        public override string ToString()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append('[');
            if (Key != null)
                builder.Append(Key.ToString());
            builder.Append(", ");
            if (Record != null)
                builder.Append(Record.ToString());
            builder.Append(']');

            return builder.ToString();
        }
    }
}
