﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace STSdb.General.Buffers
{
    public class HashCodeBuilder
    {
        private int hashCode = 37;
        private const int CONSTANT = 17;

        public override int GetHashCode()
        {
            return hashCode;
        }

        public void Append(string obj)
        {
            hashCode = hashCode * CONSTANT + obj.GetHashCode();
        }

        public void Append(byte obj)
        {
            hashCode = hashCode * CONSTANT + obj;
        }

        public void Append(int obj)
        {
            hashCode = hashCode * CONSTANT + obj;
        }

        public void Append(long obj)
        {
            hashCode = hashCode * CONSTANT + obj.GetHashCode();
        }

        public void Append(object obj)
        {
            hashCode = hashCode * CONSTANT + obj.GetHashCode();
        }

        public void Append(Type obj)
        {
            throw new Exception("Do not use.");
        }
    }
}
