﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace STSdb.General.Collections
{
    public class ListIndexer<T> : IIndexer<T>
    {
        public List<T> List;

        public ListIndexer(List<T> list)
        {
            this.List = list;
        }

        #region IIndexer<T> Members

        public T this[int index]
        {
            get { return List[index]; }
            set { List[index] = value; }
        }

        public int Count
        {
            get { return List.Count; }
        }

        #endregion
    }
}
