﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace STSdb.MTL
{
    /// <summary>
    /// Used as parameter for SELECT statement variations.
    /// </summary>
    public enum eSelectMode
    {
        /// <summary>
        /// Read is synchronized with write.
        /// <para>Bank account value change style</para>
        /// <para>When working in this mode you can be sure that</para>
        /// <para>read value is the latest and none of transaction can change it till</para>
        /// <para>your transaction is finished to work with it.</para>
        /// </summary>
        READ_SYNCHRO,
        /// <summary>
        /// Read last committed value, fast and parallel.
        /// <para>Get Report style</para>
        /// <para>If the same data is modified in parallel by other thread,</para>
        /// <para>in this mode you don't take care about it.</para>
        /// </summary>
        READ
    }

    public enum eCompareModifierUp
    {
        More,
        MoreOrEqual
    }

    public enum eCompareModifierDown
    {
        Less,
        LessOrEqual
    }

}
