﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System.IO;
using STSdb.General.Collections;
using STSdb.Files;

namespace STSdb.Persist
{
    public class BlobStreamIndexerPersist : IIndexerPersist<BlobStream>
    {
        #region IIndexerPersist<Ptr2> Members

        public void Store(BinaryWriter writer, IIndexer<BlobStream> values)
        {
            for (int i = 0; i < values.Count; i++)
            {
                BlobStream blobStream = values[i];
                writer.Write(blobStream.Offset);
                writer.Write(blobStream.Length);
            }
        }

        public void Load(BinaryReader reader, IIndexer<BlobStream> values)
        {
            for (int i = 0; i < values.Count; i++)
            {
                ulong offset = reader.ReadUInt64();
                long length = reader.ReadInt64();
                values[i] = new BlobStream(null, offset, length);
            }
        }

        #endregion
    }
}
