﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.IO;
using STSdb.General.Collections;
using STSdb.General.Buffers;

namespace STSdb.Persist
{
    public class BooleanIndexerPersist : IIndexerPersist<Boolean>
    {
        #region IIndexerPersist<bool> Members

        public void Store(BinaryWriter writer, IIndexer<bool> values)
        {
            byte[] buffer = new byte[(int)Math.Ceiling(values.Count / 8.0)];

            for (int i = 0; i < values.Count; i++)
                buffer.SetBit(i, values[i] ? 1 : 0);

            writer.Write(buffer);
        }

        public void Load(BinaryReader reader, IIndexer<bool> values)
        {
            byte[] buffer = reader.ReadBytes((int)Math.Ceiling(values.Count / 8.0));

            for (int i = 0; i < values.Count; i++)
                values[i] = buffer.GetBit(i) == 0 ? false : true;
        }

        #endregion
    }
}
