﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.IO;
using System.Runtime.InteropServices;
#if !WindowsCE && !PocketPC
using System.Runtime.Serialization.Formatters.Binary;
#endif
using STSdb.General.Collections;
using STSdb.General.Buffers;

namespace STSdb.Persist
{
    //public class PrimitiveIndexerPersist<T> : IIndexerPersist<T> 
    //{
    //    private readonly StructureIndexerPersist<T> structurePersist = new StructureIndexerPersist<T>();
    //    private readonly SerializableIndexerPersist<T> serializablePersist = new SerializableIndexerPersist<T>();
        
    //    #region IIndexerPersist<T> Members

    //    public virtual void Store(BinaryWriter writer, IIndexer<T> values)
    //    {
    //        Type type = typeof(T);
    //        TypeCode typeCode = Type.GetTypeCode(type);

    //        switch (typeCode)
    //        {
    //            case TypeCode.Boolean:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Boolean)(object)values[i]);
    //                } break;

    //            case TypeCode.Byte:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Byte)(object)values[i]);
    //                } break;
    //            case TypeCode.Char:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Char)(object)values[i]);
    //                } break;
    //            case TypeCode.DateTime:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write(((DateTime)(object)values[i]).Ticks);
    //                } break;
    //            case TypeCode.DBNull:
    //                {
    //                } break;
    //            case TypeCode.Decimal:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Decimal)(object)values[i]);
    //                } break;
    //            case TypeCode.Double:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Double)(object)values[i]);
    //                } break;
    //            case TypeCode.Empty:
    //                {
    //                } break;
    //            case TypeCode.Int16:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Int16)(object)values[i]);
    //                } break;
    //            case TypeCode.Int32:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Int32)(object)values[i]);
    //                } break;
    //            case TypeCode.Int64:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Int64)(object)values[i]);
    //                } break;
    //            case TypeCode.Object:
    //                {
    //                    if (StructurePrimitives.CanConvertStructToByteArray(type))
    //                        structurePersist.Store(writer, values);
    //                    else if (type.IsSerializable)
    //                        serializablePersist.Store(writer, values);
    //                    else
    //                        throw new NotSupportedException(type.ToString());
    //                } break;
    //            case TypeCode.SByte:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((SByte)(object)values[i]);
    //                } break;
    //            case TypeCode.Single:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((Single)(object)values[i]);
    //                } break;
    //            case TypeCode.String:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                    {
    //                        String value = (String)(object)values[i];
    //                        if (value == null)
    //                            writer.Write(false);
    //                        else
    //                        {
    //                            writer.Write(true);
    //                            writer.Write(value);
    //                        }
    //                    }
    //                } break;
    //            case TypeCode.UInt16:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((UInt16)(object)values[i]);
    //                } break;
    //            case TypeCode.UInt32:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((UInt32)(object)values[i]);
    //                } break;
    //            case TypeCode.UInt64:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        writer.Write((UInt64)(object)values[i]);
    //                } break;
    //            default:
    //                throw new NotSupportedException(typeCode.ToString());
    //        }
    //    }

    //    public virtual void Load(BinaryReader reader, IIndexer<T> values)
    //    {
    //        Type type = typeof(T);
    //        TypeCode typeCode = Type.GetTypeCode(type);

    //        switch (typeCode)
    //        {
    //            case TypeCode.Boolean:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadBoolean();
    //                } break;
    //            case TypeCode.Byte:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadByte();
    //                } break;
    //            case TypeCode.Char:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadChar();
    //                } break;
    //            case TypeCode.DateTime:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)new DateTime(reader.ReadInt64());
    //                } break;
    //            case TypeCode.DBNull:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)DBNull.Value;
    //                } break;
    //            case TypeCode.Decimal:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadDecimal();
    //                } break;
    //            case TypeCode.Double:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadDouble();
    //                } break;
    //            case TypeCode.Empty:
    //                {
    //                } break;
    //            case TypeCode.Int16:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadInt16();
    //                } break;
    //            case TypeCode.Int32:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadInt32();
    //                } break;
    //            case TypeCode.Int64:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadInt64();
    //                } break;
    //            case TypeCode.Object:
    //                {
    //                    if (StructurePrimitives.CanConvertStructToByteArray(type))
    //                        structurePersist.Load(reader, values);
    //                    else if (type.IsSerializable)
    //                        serializablePersist.Load(reader, values);
    //                    else
    //                        throw new NotSupportedException(type.ToString());
    //                } break;
    //            case TypeCode.SByte:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadSByte();
    //                } break;
    //            case TypeCode.Single:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadSingle();
    //                } break;
    //            case TypeCode.String:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = reader.ReadBoolean() ? (T)(object)reader.ReadString() : default(T);
    //                } break;
    //            case TypeCode.UInt16:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadUInt16();
    //                } break;
    //            case TypeCode.UInt32:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadUInt32();
    //                } break;
    //            case TypeCode.UInt64:
    //                {
    //                    for (int i = 0; i < values.Count; i++)
    //                        values[i] = (T)(object)reader.ReadUInt64();
    //                } break;
    //            default:
    //                throw new NotSupportedException(typeCode.ToString());
    //        }
    //    }

    //    #endregion
    //}
}
