﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using STSdb.General.Reflection;
using STSdb.General.Collections;

namespace STSdb.Persist
{
    public class PropertyIndexer<TRecord, TProperty> : IIndexer<TProperty>
    {
        public readonly IIndexer<TRecord> Indexer;
        public readonly PropertyReflector<TRecord, TProperty> Property;

        public PropertyIndexer(IIndexer<TRecord> indexer, PropertyReflector<TRecord, TProperty> property)
        {
            Indexer = indexer;
            Property = property;
        }

        #region IIndexer<TRecord> Members

        public TProperty this[int index]
        {
            get
            {
                TRecord record = Indexer[index];
                return Property.GetValue(record);
            }
            set
            {
                TRecord record = Indexer[index];
                Property.SetValue(record, value);
            }
        }

        public int Count
        {
            get { return Indexer.Count; }
        }

        #endregion
    }
}
