﻿/* Copyright (C) 2007-2010 STS Soft

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

using System.IO;
using STSdb.General.Collections;
using STSdb.Files;

namespace STSdb.Persist
{
    public class PtrIndexerPersist : IIndexerPersist<Ptr>
    {
        #region IIndexerPersist<Ptr2> Members

        public void Store(BinaryWriter writer, IIndexer<Ptr> values)
        {
            for (int i = 0; i < values.Count; i++)
                values[i].Serialize(writer);
        }

        public void Load(BinaryReader reader, IIndexer<Ptr> values)
        {
            for (int i = 0; i < values.Count; i++)
                values[i] = Ptr.Deserialize(reader);
        }

        #endregion
    }
}
